"""
Django settings for Listaflow.

Generated by 'django-admin startproject' using Django 4.0.

For more information on this file, see
https://docs.djangoproject.com/en/4.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.0/ref/settings/
"""
import os
from datetime import timedelta
from pathlib import Path

import environ
from celery.schedules import crontab
from django.utils.translation import gettext_lazy as _

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent.parent
env = environ.Env()

READ_DOT_ENV_FILE = env.bool("DJANGO_READ_DOT_ENV_FILE", default=False)
if READ_DOT_ENV_FILE:
    # OS environment variables take precedence over variables from .env
    env.read_env(str(BASE_DIR / ".env"))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.0/howto/deployment/checklist/

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = env.bool("DEBUG", False)

ALLOWED_HOSTS = []

# REACT FRONTEND
# ------------------------------------------------------------------------------
# URL to the react frontend.
FRONTEND_URL = env.str("FRONTEND_URL", "http://localhost:8000")
CORS_ALLOWED_ORIGINS = [FRONTEND_URL]
CACHE_KEY_DELIMITER = env.str("DJANGO_CACHE_KEY_DELIMITER", ":")

DEFAULT_LOCALE_PATH = "./locale"
LOCALE_PATH = env.str("LOCALE_PATH", DEFAULT_LOCALE_PATH)
if not os.path.isabs(LOCALE_PATH):
    LOCALE_PATH = BASE_DIR / LOCALE_PATH

LOCALE_PATHS = (LOCALE_PATH,)

LANGUAGES = [
    ("en", _("English")),
    ("vi", _("Vietnamese")),
    ("ar", _("Arabic")),
]

# Application definition

INSTALLED_APPS = [
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "djcelery_email",
    "corsheaders",
    "drf_yasg",
    "django_better_admin_arrayfield",
    "lib",
    "workflow",
    "profiles",
    "oauth2_provider",
    "social_django",
    "rest_framework",
    "drf_social_oauth2",
    "rest_registration",
    "django_celery_beat",
    "django_filters",
]

MIDDLEWARE = [
    "corsheaders.middleware.CorsMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "oauth2_provider.middleware.OAuth2TokenMiddleware",
    "profiles.middleware.CustomSocialAuthExceptionMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "django.middleware.locale.LocaleMiddleware",
    "middlewares.api_locale.ApiLocaleMiddleware",
]

ROOT_URLCONF = "conf.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [BASE_DIR / "templates"],
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "social_django.context_processors.backends",
                "social_django.context_processors.login_redirect",
            ],
        },
    },
]

WSGI_APPLICATION = "conf.wsgi.application"

# CACHES
# ------------------------------------------------------------------------------
CACHES = {
    "default": {
        "BACKEND": "django_redis.cache.RedisCache",
        "LOCATION": env("REDIS_URL"),
        "OPTIONS": {
            "CLIENT_CLASS": "django_redis.client.DefaultClient",
            # Mimicing memcache behavior.
            # https://github.com/jazzband/django-redis#memcached-exceptions-behavior
            "IGNORE_EXCEPTIONS": True,
        },
    }
}

# Database
# https://docs.djangoproject.com/en/4.0/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql",
        "NAME": env.str("DATABASE_NAME", "django_db"),
        "HOST": env.str("DATABASE_HOST", "localhost"),
        "PORT": env.int("DATABASE_PORT", 5432),
        "USER": env.str("DATABASE_USER", "django_user"),
        "PASSWORD": env.str("DATABASE_PASSWORD", "django_password"),
    }
}

PASSWORD_HASHERS = [
    # Use a password hasher that can't be ASIC accelerated.
    "django.contrib.auth.hashers.Argon2PasswordHasher",
]

# https://docs.djangoproject.com/en/dev/ref/settings/#auth-user-model
AUTH_USER_MODEL = "profiles.User"

# EMAIL
# ------------------------------------------------------------------------------
# https://docs.djangoproject.com/en/dev/ref/settings/#email-backend
# To avoid complicating the writing of tasks which send email, we have the email
# backend handled by django-celery-email. This will prevent issues like temporary
# network errors interrupting a loop early.
EMAIL_BACKEND = "djcelery_email.backends.CeleryEmailBackend"

CELERY_EMAIL_BACKEND = env.str(
    "DJANGO_EMAIL_BACKEND", "django.core.mail.backends.smtp.EmailBackend"
)
# https://docs.djangoproject.com/en/dev/ref/settings/#default-from-email
DEFAULT_FROM_EMAIL = env.str(
    "DJANGO_DEFAULT_FROM_EMAIL", "Listaflow <noreply@listaflow.com>"
)
# reply-to email
DEFAULT_REPLY_TO_EMAILS = env.list(
    "DJANGO_DEFAULT_REPLY_TO_EMAILS", default=[DEFAULT_FROM_EMAIL]
)

# Password validation
# https://docs.djangoproject.com/en/4.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": (
            "django.contrib.auth.password_validation"
            ".UserAttributeSimilarityValidator"
        ),
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.0/topics/i18n/

LANGUAGE_CODE = env.str("DEFAULT_LANGUAGE_CODE", "en-us")
API_LANGUAGE_HEADER = env.str("API_LANGUAGE_HEADER", "content-language")

TIME_ZONE = "UTC"

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.0/howto/static-files/

STATIC_URL = "static/"

STATIC_ROOT = env.str("STATIC_ROOT", BASE_DIR)

STATICFILES_DIRS = [BASE_DIR / "static"]

# Default primary key field type
# https://docs.djangoproject.com/en/4.0/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

# Swagger settings

SWAGGER_SETTINGS = {
    "SECURITY_DEFINITIONS": {
        "cookieAuth": {
            "type": "apiKey",
            "in": "cookie",
            "name": "sessionid",
        },
    }
}

AUTHENTICATION_BACKENDS = (
    "social_core.backends.google.GoogleOAuth2",
    "drf_social_oauth2.backends.DjangoOAuth2",
    "django.contrib.auth.backends.ModelBackend",
)
DEFAULT_WHITELISTED_DOMAINS = env.list(
    "DJANGO_DEFAULT_WHITELISTED_DOMAINS", default=["opencraft.com"]
)

SOCIAL_AUTH_GOOGLE_OAUTH2_WHITELISTED_DOMAINS = DEFAULT_WHITELISTED_DOMAINS
# the get_username pipeline can apply a slug transformation
SOCIAL_AUTH_SLUGIFY_USERNAMES = False

#  it’s recommended to use the built-in JSONB field with Postgresql
SOCIAL_AUTH_JSONFIELD_ENABLED = True

SOCIAL_AUTH_GOOGLE_OAUTH2_SCOPE = [
    "https://www.googleapis.com/auth/userinfo.email",
    "https://www.googleapis.com/auth/userinfo.profile",
    "openid",
]
GOOGLE_CREDENTIALS = env.json("GOOGLE_CREDENTIALS", default={})

SOCIAL_AUTH_USER_FIELDS = ["email", "username", "first_name", "password"]

SOCIAL_AUTH_PIPELINE = (
    # Get the information we can about the user and return it in a simple
    # format to create the user instance later. In some cases the details are
    # already part of the auth response from the provider, but sometimes this
    # could hit a provider API.
    "social_core.pipeline.social_auth.social_details",
    # Get the social uid from whichever service we're authing thru. The uid is
    # the unique identifier of the given user in the provider.
    "social_core.pipeline.social_auth.social_uid",
    # Verifies that the current auth process is valid within the current
    # project, this is where emails and domains whitelists are applied (if
    # defined).
    "social_core.pipeline.social_auth.auth_allowed",
    # Checks if the current social-account is already associated in the site.
    "social_core.pipeline.social_auth.social_user",
    # Make up a username for this person, appends a random string at the end if
    # there's any collision.
    "social_core.pipeline.user.get_username",
    # Send a validation email to the user to verify its email address.
    # Disabled by default.
    # 'social_core.pipeline.mail.mail_validation',
    # Associates the current social details with another user account with
    # a similar email address. Disabled by default.
    "social_core.pipeline.social_auth.associate_by_email",
    # Create a user account if we haven't found one yet.
    "profiles.pipeline.create_user",
    # Create the record that associates the social account with the user.
    "social_core.pipeline.social_auth.associate_user",
    # Populate the extra_data field in the social record with the values
    # specified by settings (and the default ones like access_token, etc).
    "social_core.pipeline.social_auth.load_extra_data",
    # Update the user record with any changed info from the auth service.
    "social_core.pipeline.user.user_details",
)

REST_FRAMEWORK = {
    "DEFAULT_PAGINATION_CLASS": "workflow.pagination.StandardResultsSetPagination",
    "PAGE_SIZE": 24,
    "DEFAULT_AUTHENTICATION_CLASSES": (
        "oauth2_provider.contrib.rest_framework.OAuth2Authentication",
        "drf_social_oauth2.authentication.SocialAuthentication",
        "rest_framework.authentication.SessionAuthentication",
    ),
    "DEFAULT_FILTER_BACKENDS": ["django_filters.rest_framework.DjangoFilterBackend"],
}

REST_REGISTRATION = {
    "REGISTER_VERIFICATION_URL": f"{FRONTEND_URL}/verify-user/",
    "RESET_PASSWORD_VERIFICATION_URL": f"{FRONTEND_URL}/reset-password/",
    "VERIFICATION_FROM_EMAIL": DEFAULT_FROM_EMAIL,
    "REGISTER_SERIALIZER_CLASS": "profiles.serializers.RegisterSerializer",
    "REGISTER_VERIFICATION_ENABLED": True,
    "REGISTER_VERIFICATION_EMAIL_TEMPLATES": {
        "subject": "email/verify_user/subject.txt",
        "text_body": "email/verify_user/body.txt",
        "html_body": "email/verify_user/body.html",
    },
    "RESET_PASSWORD_VERIFICATION_EMAIL_TEMPLATES": {
        "subject": "email/reset_password/subject.txt",
        "text_body": "email/reset_password/body.txt",
        "html_body": "email/reset_password/body.html",
    },
    "REGISTER_SERIALIZER_PASSWORD_CONFIRM": False,
    "REGISTER_VERIFICATION_PERIOD": timedelta(hours=2),
    "REGISTER_EMAIL_VERIFICATION_ENABLED": False,
    "REGISTER_VERIFICATION_ONE_TIME_USE": True,
    "REGISTER_VERIFICATION_AUTO_LOGIN": True,
    "RESET_PASSWORD_FAIL_WHEN_USER_NOT_FOUND": False,
    "RESET_PASSWORD_VERIFICATION_ONE_TIME_USE": True,
}

# Celery configs.
CELERY_TIMEZONE = env.str("CELERY_TIMEZONE", "")
CELERY_ALWAYS_EAGER = env.bool("CELERY_ALWAYS_EAGER", False)
CELERY_EAGER_PROPAGATES = env.bool("CELERY_EAGER_PROPAGATES", False)
CELERY_BROKER_TRANSPORT = env.str("CELERY_BROKER_TRANSPORT", "redis")
CELERY_BROKER_USER = env.str("CELERY_BROKER_USER", "")
CELERY_BROKER_HOSTNAME = env.str("CELERY_BROKER_HOSTNAME", "")
CELERY_BROKER_VHOST = env.str("CELERY_BROKER_VHOST", "")
CELERY_BROKER_PASSWORD = env.str("CELERY_BROKER_PASSWORD", "")
CELERY_BROKER_USE_SSL = env.str("CELERY_BROKER_USE_SSL", False)
DEFAULT_CELERY_BROKER_URL = (
    f"{CELERY_BROKER_TRANSPORT}://{CELERY_BROKER_USER}:{CELERY_BROKER_PASSWORD}"
    f"@{CELERY_BROKER_HOSTNAME}/{CELERY_BROKER_VHOST}"
)
CELERY_BROKER_URL = env.str("CELERY_BROKER_URL", DEFAULT_CELERY_BROKER_URL)
DEFAULT_CELERY_RESULT_BACKEND = (
    f"{CELERY_BROKER_TRANSPORT}://{CELERY_BROKER_USER}:{CELERY_BROKER_PASSWORD}"
    f"@{CELERY_BROKER_HOSTNAME}/1"
)
CELERY_RESULT_BACKEND = env.str("CELERY_RESULT_BACKEND", DEFAULT_CELERY_RESULT_BACKEND)
CELERY_BEAT_SCHEDULER = "django_celery_beat.schedulers:DatabaseScheduler"
CELERY_BEAT_SCHEDULE = {
    "send-reminder-emails": {
        "task": "workflow.tasks.send_reminder_emails",
        "schedule": crontab(minute=0, hour=0),
    },
}
